#!/usr/bin/python


# Originally written by Bram Cohen
# Modifications by kRYPT
# see LICENSE.txt for license information

from sys import argv, version
from os.path import isdir
from btcompletedir import completedir
from threading import Event, Thread
from os.path import join
from os import getcwd
from wxPython.wx import *
from webbrowser import open_new 

wxEVT_INVOKE = wxNewEventType()

trackerList = ['http://qa.mandrakesoft.com:6969/announce']
urlList = ['http://qa.mandrakesoft.com/torrent']

def EVT_INVOKE(win, func):
    win.Connect(-1, -1, wxEVT_INVOKE, func)

class InvokeEvent(wxPyEvent):
    def __init__(self, func, args, kwargs):
        wxPyEvent.__init__(self)
        self.SetEventType(wxEVT_INVOKE)
        self.func = func
        self.args = args
        self.kwargs = kwargs

class DownloadInfo:
    def __init__(self):
        frame = wxFrame(None, -1, 'MakeTorrent 1.2 (based on completedir 1.0.1)', size = wxSize(550, 250))
        self.frame = frame

        panel = wxPanel(frame, -1)

        gridSizer = wxFlexGridSizer(cols = 2, rows = 3, vgap = 15, hgap = 8)
        
        gridSizer.Add(wxStaticText(panel, -1, 'build:'))
        self.dirCtl = wxTextCtrl(panel, -1, '')

        b = wxBoxSizer(wxHORIZONTAL)
        b.Add(self.dirCtl, 1, wxEXPAND)
        b.Add(10, 10, 0, wxEXPAND)
        button = wxButton(panel, -1, '(dir)', size = (40,21))
        b.Add(button, 0, wxEXPAND)
        EVT_BUTTON(frame, button.GetId(), self.selectdir)

        b.Add(5, 5, 0, wxEXPAND)
        button2 = wxButton(panel, -1, '(file)', size = (40,21))
        b.Add(button2, 0, wxEXPAND)
        EVT_BUTTON(frame, button2.GetId(), self.selectfile)

        gridSizer.Add(b, 0, wxEXPAND)

        gridSizer.Add(wxStaticText(panel, -1, 'announce url:'))

        self.annCtl = wxComboBox(panel, -1, '(enter a tracker URL, or select from list below)', wxPoint(90, 50), wxSize(95, -1), trackerList, wxCB_DROPDOWN)

	c = wxBoxSizer(wxHORIZONTAL)
        c.Add(self.annCtl, 1, wxEXPAND)
        c.Add(10, 10, 0, wxEXPAND)
        visitBtn = wxButton(panel, -1, 'visit', size = (40,21))
        c.Add(visitBtn, 0, wxEXPAND)
        EVT_BUTTON(frame, visitBtn.GetId(), self.visit)

        gridSizer.Add(c, 0, wxEXPAND)

	gridSizer.Add(wxStaticText(panel, -1, 'comment:'))
	self.commentCtl = wxTextCtrl(panel, -1, '')
	gridSizer.Add(self.commentCtl, 0, wxEXPAND)

        gridSizer.Add(wxStaticText(panel, -1, 'piece size:'))
        self.piece_length = wxChoice(panel, -1, choices = ['2048 kB', '1024 kB', '512 kB', 
            '(auto)', '256 kB', '128 kB', '64 kB', '32 kB'])
        self.piece_length.SetSelection(3)
        gridSizer.Add(self.piece_length)

        gridSizer.AddGrowableCol(1)
 
	self.aboutText = wxStaticText(panel, -1, 'homepage', (450, 200), style = wxALIGN_RIGHT)
	self.aboutText.SetForegroundColour('Blue')
	self.aboutText.SetFont(wxFont(12, wxNORMAL, wxNORMAL, wxNORMAL, true)) 

        border = wxBoxSizer(wxVERTICAL)
        border.Add(gridSizer, 0, wxEXPAND | wxNORTH | wxEAST | wxWEST, 25)
        b2 = wxButton(panel, -1, 'create torrent')
        border.Add(10, 10, 1, wxEXPAND)
        border.Add(b2, 0, wxALIGN_CENTER | wxSOUTH, 20)
        EVT_LEFT_DOWN(self.aboutText, self.about) 
	EVT_BUTTON(frame, b2.GetId(), self.complete)
        panel.SetSizer(border)
        panel.SetAutoLayout(True)

    def about(self, x):
      	open_new('http://krypt.dyndns.org:81/torrent/maketorrent/') 

    def selectdir(self, x):
        dl = wxDirDialog(self.frame, style = wxDD_DEFAULT_STYLE | wxDD_NEW_DIR_BUTTON)
        if dl.ShowModal() == wxID_OK:
            self.dirCtl.SetValue(dl.GetPath())
	dl.Destroy()

    def selectfile(self, x):
        dl = wxFileDialog(self.frame, "Choose a file", "", "", "All Files|*.*", wxOPEN)
        if dl.ShowModal() == wxID_OK:
            self.dirCtl.SetValue(dl.GetPath())
	dl.Destroy()

    def visit(self,x):
    	if self.annCtl.GetSelection() is not -1:
	    open_new(urlList[self.annCtl.GetSelection()])    	

    def complete(self, x):
        if self.dirCtl.GetValue() == '':
            dlg = wxMessageDialog(self.frame, message = 'You must select a directory', 
                caption = 'Error', style = wxOK | wxICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return
        try:
	    if self.annCtl.GetValue() == '(enter a tracker URL, or select from list below)':
	        dlg = wxMessageDialog(self.frame, 'Enter a tracker URL, or click the down arrow to select from common, public trackers.', 'Error: Enter announce url', wxOK | wxICON_ERROR)
                dlg.ShowModal()
		dlg.Destroy()
	    else:
	        proceed = true
	        if isdir(self.dirCtl.GetValue()):	        
			dlg = wxSingleChoiceDialog(self.frame, 'What type of torrent(s) do you wish to make:', 'Select Action',
                               ['1 torrent from entire folder', '1 torrent for each file'], wxOK|wxCANCEL)
			if dlg.ShowModal() == wxID_OK:
			   mode = dlg.GetSelection()
			else:
		           proceed = false
	                dlg.Destroy()
		else:
			mode = 0

                if proceed == true:
			if self.piece_length.GetSelection() == 3:
				CompleteDir(self.dirCtl.GetValue(), self.annCtl.GetValue(), None, mode, self.commentCtl.GetValue())
			elif self.piece_length.GetSelection() > 3:
			        ps = 22 - self.piece_length.GetSelection()
		                CompleteDir(self.dirCtl.GetValue(), self.annCtl.GetValue(), ps, mode, self.commentCtl.GetValue())
			else:
			        ps = 21 - self.piece_length.GetSelection()
		                CompleteDir(self.dirCtl.GetValue(), self.annCtl.GetValue(), ps, mode, self.commentCtl.GetValue())
        except:
            print_exc()

from traceback import print_exc

class CompleteDir:
    def __init__(self, d, a, pl, mode, c):
        self.d = d
        self.a = a
        self.pl = pl
	self.mode = mode
	self.c = c
	self.flag = Event()

        frame = wxFrame(None, -1, 'Working ...', size = wxSize(550, 250))
        self.frame = frame

        panel = wxPanel(frame, -1)

        gridSizer = wxFlexGridSizer(cols = 1, vgap = 15, hgap = 8)

        self.currentLabel = wxStaticText(panel, -1, 'Checking File Sizes...')
        gridSizer.Add(self.currentLabel, 0, wxEXPAND)
        self.gauge = wxGauge(panel, -1, range = 1000, style = wxGA_SMOOTH)
        gridSizer.Add(self.gauge, 0, wxEXPAND)
        gridSizer.Add(10, 10, 1, wxEXPAND)
        self.button = wxButton(panel, -1, 'cancel')
        gridSizer.Add(self.button, 0, wxALIGN_CENTER)
        gridSizer.AddGrowableRow(2)
        gridSizer.AddGrowableCol(0)

        g2 = wxFlexGridSizer(cols = 1, vgap = 15, hgap = 8)
        g2.Add(gridSizer, 1, wxEXPAND | wxALL, 25)
        g2.AddGrowableRow(0)
        g2.AddGrowableCol(0)
        panel.SetSizer(g2)
        panel.SetAutoLayout(True)
        EVT_BUTTON(frame, self.button.GetId(), self.done)
        EVT_CLOSE(frame, self.done)
        EVT_INVOKE(frame, self.onInvoke)
        frame.Show(True)
        Thread(target = self.complete).start()

    def complete(self):
        try:
            completedir(self.d, self.a, self.flag, self.valcallback, self.filecallback, self.pl, self.mode, self.c)
            if not self.flag.isSet():
                self.currentLabel.SetLabel('Done!')
                self.gauge.SetValue(1000)
                self.button.SetLabel('Close')
        except (OSError, IOError), e:
            self.currentLabel.SetLabel('Error!')
            self.button.SetLabel('Close')
            dlg = wxMessageDialog(self.frame, message = 'Error - ' + str(e), 
                caption = 'Error', style = wxOK | wxICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()

    def valcallback(self, amount):
        if not self.flag.isSet():
           self.invokeLater(self.onval, [amount])

    def onval(self, amount):
        if not self.flag.isSet():
           self.gauge.SetValue(int(amount * 1000))

    def filecallback(self, f):
        self.invokeLater(self.onfile, [f])

    def onfile(self, f):
        if not self.flag.isSet():
           self.currentLabel.SetLabel('Creating: ' + join(self.d, f) + '.torrent')

    def onInvoke(self, event):
        if not self.flag.isSet():
            apply(event.func, event.args, event.kwargs)

    def invokeLater(self, func, args = [], kwargs = {}):
        if not self.flag.isSet():
            wxPostEvent(self.frame, InvokeEvent(func, args, kwargs))

    def done(self, event):
        self.flag.set()
        self.frame.Destroy()

class btWxApp(wxApp):
    def OnInit(self):
        d = DownloadInfo()
        d.frame.Show(True)
        self.SetTopWindow(d.frame)
        return True

if __name__ == '__main__':
    btWxApp().MainLoop()
